#include "../include/useful_funcs.h"
#include <algorithm>
#include <cstddef>
#include <errno.h>
#include <fstream>
#include <iostream>
#include <sstream>
#include <string>
#include <vector>

int main() {
  std::ifstream inputfile("input");
  std::string input;

  int res = 0;
  if (inputfile.is_open()) {
    std::string line;
    std::vector<std::string> num_s;
    std::vector<int> num;

    while (std::getline(inputfile, line)) {
      num_s = splitString(line);
      num.clear();

      ConvertStringVectorToIntVector(num_s, num);

      // decreasing
      bool safe = true;
      for (size_t i = 1; i < num.size(); ++i) {
        int diff = num[i - 1] - num[i];
        if (diff < 1 || diff > 3) {
          safe = false;
          break;
        }
      }

      if (safe) {
        res++;
        std::clog << line << std::endl;
        continue;
      }

      // increasing
      safe = true;
      for (size_t i = 1; i < num.size(); ++i) {
        int diff = num[i] - num[i - 1];
        if (diff < 1 || diff > 3) {
          safe = false;
          break;
        }
      }

      if (safe) {
        std::clog << line << std::endl;
        res++;
      }
    }

    inputfile.close();
  } else {
    std::cerr << "Unable to open file!" << std::endl;
    return ENOENT;
  }

  std::cout << res << std::endl;
  return 0;
}
